/**
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.siddhi.sample.benchmark.client;

public class Client {

    public static final int DEFAULT_PORT = 4444;
    public static final String DEFAULT_HOST = "localhost";
                                                                       ;
    private String host;
    private int port;
    private long batchWait;
    private static boolean hasDefaultPort = true;
    private static boolean hasDefaultHost = true;

    public Client(String host, int port, long batchWait) {
        this.host = host;
        this.port=port;
        this.batchWait = batchWait;
    }                                                 

    public Client(){
      this.port = DEFAULT_PORT;
      this.host = DEFAULT_HOST;
      this.batchWait = 0;
    }

    public long getBatchWait(){
    return batchWait;
    }

    public int getPort(){
    return port;
    }

    public String getHost(){
    return host;
    }

    public static void main(String[] args) {
       int port = 0;
       long batchWait = 0;

       String host = "";
       Client client = null;

      for(int i=0;i<args.length;i++) {  // filter the parameters passed to the main method from the client.sh
         if("-host".equals(args[i])){
         i++;
         host = args[i];
         hasDefaultHost = false;
         } else if("-port".equals(args[i])){
         i++;
         port = Integer.valueOf(args[i]);
         hasDefaultPort = false;
         } else if("-batch_wait".equals(args[i])){
         i++;
         batchWait = Long.valueOf(args[i]);
         }
      }
    if(hasDefaultHost && hasDefaultPort) {
         client = new Client();

    } else if (!hasDefaultHost && !hasDefaultPort) {
         client = new Client(host,port,batchWait);
    } else {
        throw new RuntimeException("Invalid Client initiation..!!! Please refer the README.txt");
    }
        new StockQuoteClient(client).start();  // initiate the client thread which sends events to the given host
    
    }




}
